/*
 * Copyright (C) 2017 C-SKY Microsystems Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/******************************************************************************
 * @file     csky_stackbound.c
 * @brief    the function serverd for STACK GUARD
 * @version  V1.0
 * @date     20. July 2016
 ******************************************************************************/

#include <os.h>

void csky_set_stackbound(void)
{
    CPU_STK_SIZE size;
    CPU_STK      *base;

    OS_TCB *get_task = (OS_TCB *)OSTCBCurPtr;

    base = get_task->StkBasePtr;
    size = get_task->StkSize;

    asm volatile(
        "mfcr    r9, cr<0, 4>\n\r"
        "bclri   r9, 0\n\r"
        "mtcr    r9, cr<0, 4>\n\r"
        "mtcr    %0, cr<2, 4>\n\r"
        "lsli    %1, %1, 2\n\r"
        "add     %0, %0, %1\n\r"
        "mtcr    %0, cr<1, 4>\n\r"
        ::"r"(base), "r"(size):"r9");
}
