/*
 * Copyright (C) 2017 C-SKY Microsystems Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/******************************************************************************
 * @file     example_mpu.c
 * @brief    the main function for the timer driver
 * @version  V1.0
 * @date     25. March 2017
 ******************************************************************************/

#include <stdint.h>
#include <stdio.h>
#include <soc.h>
#include <csi_core.h>

#define TEST_BUF_SIZE 4096
static uint8_t __attribute__((aligned(TEST_BUF_SIZE))) test_buf[TEST_BUF_SIZE];

int example_mpu(void)
{
    mpu_region_attr_t attr;

    attr.nx = 0;
    attr.ap = AP_BOTH_RW;
    attr.s = 0;

    csi_mpu_config_region(3, (uint32_t)&test_buf, REGION_SIZE_4KB, attr, 1);

    printf("MPU region 3 has been confiured and enabled.\n\r");
    printf("region 3: 0x%x--0x%x\n", (uint32_t)&test_buf, (uint32_t)&test_buf + TEST_BUF_SIZE);

    csi_mpu_disable_region(3);

    printf("Example run successfully!\n");

    return 0;
}

int main(void)
{
    return example_mpu();
}
